@echo off
goto begin

rem **
rem ** Author: Cosmin Truta <cosmint@cs.ubbcluj.ro>
rem ** Babes-Bolyai University, Cluj-Napoca, Romania, 1996,97
rem **

:begin
echo **
echo ** Build a Run-Time Library for Delphi 1.0
echo ** using Borland Pascal & Delphi Run-Time Library Source Code.
echo **

if [%1]==[] goto usage
if [%2]==[] goto usage
if not exist sys\system.pas goto notice
if [%3]==[DEBUG] goto debug
if [%3]==[debug] goto debug
if not [%3]==[] goto usage

:release
echo ** Building release version ...
echo **
make -DBP=%1 -DDELPHI=%2 -f rtl80.mak
goto done

:debug
echo ** Building debug version ...
echo **
make -DBP=%1 -DDELPHI=%2 -DDEBUG=1 -f rtl80.mak

:done
if errorlevel 1 goto error
echo **
echo ** Library created.
echo **
echo ** When you wish to clean the source code, type:
echo ** MAKE -DDELPHI=%2 -f rtl80.mak clean
echo **
goto end

:usage
echo ** Usage: Build80 {BP directory} {Delphi directory} [debug]
echo **
echo ** You must have Borland Pascal Run-Time Library Source Code
echo **    and Delphi Run-Time Library Source Code installed.

:notice
echo ** This package must be in the Delphi Source\RTL directory.
echo **
goto end

:error
echo **
echo ** Error in building the library.
echo **

:end
